<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
                xmlns:kml="http://www.opengis.net/kml/2.2">
    <xsl:output method="html"/>

    <xsl:template match="/">
        <html xmlns="http://www.w3.org/1999/xhtml">
            <head>
                <title>Simple click event</title>
                <meta name="viewport" content="initial-scale=1.0, user-scalable=no"/>
                <meta charset="utf-8"/>
                <style>
                    html, body, #map-canvas {
                        width: 400px;
                        height: 400px;
                        margin: 0px;
                        padding: 0px
                    }
                </style>
                <script src="https://maps.googleapis.com/maps/api/js?v=3.exp&amp;sensor=false"/>
                <script>
function initialize() {
    var mapOptions = {
        zoom: 16,
        center: new google.maps.LatLng(<xsl:apply-templates select="/GeocodeResponse/result/geometry/location"/>)
    };
    var map = new google.maps.Map(document.getElementById('map-canvas'), mapOptions);
    [<xsl:apply-templates select="/GeocodeResponse/result/geometry/kml:coordinates"/>].forEach(function(m) {
        var marker = new google.maps.Marker({
            position: new google.maps.LatLng(m[0], m[1]),
            map: map,
            title: 'Distance='+m[2]
        });
        google.maps.event.addListener(marker, 'click', function() {
            window.location.replace('https://maps.google.com/maps?saddr=<xsl:apply-templates
                        select="/GeocodeResponse"/>&amp;daddr='+m[0]+','+m[1]);
        });
    })
}
google.maps.event.addDomListener(window, 'load', initialize);
                </script>
            </head>
            <body>
                <div id="map-canvas"/>
            </body>
        </html>
    </xsl:template>
    
    <xsl:template match="GeocodeResponse">
        <xsl:value-of select="Latitude"/>,<xsl:value-of select="Longitude"/>
    </xsl:template>
    <xsl:template match="location">
        <xsl:value-of select="lat"/>,<xsl:value-of select="lng"/>
    </xsl:template>
    <xsl:template match="kml:coordinates">
        [<xsl:value-of select="@lat"/>,<xsl:value-of select="@lng"/>,<xsl:value-of select="@Distance"/>],<xsl:text/>
    </xsl:template>
</xsl:stylesheet>