<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
                xmlns:xalan="http://xml.apache.org/xalan"
                xmlns:tpl="http://software.in2p3.fr/lavoisier/template.xsd">
    <xsl:output method="xml" indent="yes" xalan:indent-amount="4"/>
    <xsl:variable name="xsl">http://www.w3.org/1999/XSL/Transform</xsl:variable>

    <xsl:template match="/">
        <xsl:element name="xsl:stylesheet" namespace="{$xsl}">
            <xsl:attribute name="version">1.0</xsl:attribute>
            <xsl:comment> generated by module html-template-engine </xsl:comment>
            <xsl:element name="xsl:output" namespace="{$xsl}"><xsl:attribute name="method">html</xsl:attribute></xsl:element>
            <!-- entry point -->
            <xsl:element name="xsl:template" namespace="{$xsl}">
                <xsl:attribute name="match">/</xsl:attribute>
                <xsl:apply-templates/>
            </xsl:element>
            <!-- duplicated templates -->
            <xsl:for-each select="//*[@id=//*/@tpl:duplicate]">
                <xsl:element name="xsl:template" namespace="{$xsl}">
                    <xsl:attribute name="name"><xsl:value-of select="@id"/></xsl:attribute>
                    <xsl:copy-of select="namespace::*"/>
                    <xsl:apply-templates/>
                </xsl:element>
            </xsl:for-each>
            <!-- user templates -->
            <xsl:copy-of select="//xsl:template"/>
            <!-- tokenizer callbacks -->
            <xsl:element name="xsl:template" namespace="{$xsl}">
                <xsl:attribute name="name">process-token</xsl:attribute>
                <xsl:element name="xsl:param" namespace="{$xsl}"><xsl:attribute name="name">token</xsl:attribute></xsl:element>
                <xsl:element name="xsl:param" namespace="{$xsl}"><xsl:attribute name="name">position</xsl:attribute></xsl:element>
                <xsl:element name="xsl:param" namespace="{$xsl}"><xsl:attribute name="name">last</xsl:attribute></xsl:element>
                <xsl:element name="xsl:param" namespace="{$xsl}"><xsl:attribute name="name">callback</xsl:attribute></xsl:element>
                <xsl:element name="xsl:choose" namespace="{$xsl}">
                    <xsl:element name="xsl:when" namespace="{$xsl}">
                        <xsl:attribute name="test">false()</xsl:attribute>
                    </xsl:element>
                    <xsl:for-each select="//*[@tpl:foreach-token]">
                        <xsl:element name="xsl:when" namespace="{$xsl}">
                            <xsl:attribute name="test">$callback = <xsl:value-of select="position()"/></xsl:attribute>
                            <xsl:apply-templates select="self::*" mode="VARIABLE"/>
                        </xsl:element>
                    </xsl:for-each>
                </xsl:element>
            </xsl:element>
            <!-- copy functions -->
            <xsl:copy-of select="document('/xsl/functions.xsl')/xsl:stylesheet/xsl:template[not(@name='process-token')]"/>
        </xsl:element>
    </xsl:template>

    <xsl:template match="*[@tpl:*]">
        <xsl:if test="count(@tpl:foreach|@tpl:foreach-token|@tpl:if|@tpl:else) > 1">
            <xsl:message terminate="yes">ERROR: attributes 'foreach','foreach-token','if' and 'else' can not coexist</xsl:message>
        </xsl:if>
        <xsl:if test="@tpl:with-order and not(@tpl:foreach)">
            <xsl:message terminate="yes">ERROR: attribute 'with-order' requires attribute 'foreach'</xsl:message>
        </xsl:if>
        <xsl:if test="@tpl:with-delimiter and not(@tpl:foreach-token)">
            <xsl:message terminate="yes">ERROR: attribute 'with-delimiter' requires attribute 'foreach-token'</xsl:message>
        </xsl:if>
        <xsl:if test="@tpl:with-param and not(@tpl:call-function)">
            <xsl:message terminate="yes">ERROR: attribute 'with-param' requires attribute 'call-function'</xsl:message>
        </xsl:if>
        <xsl:if test="count(@tpl:text|@tpl:xml|@tpl:call-function|@tpl:duplicate|*[1]) > 1">
            <xsl:message terminate="yes">ERROR: attributes 'text','call-function','duplicate' and child elements can not coexist</xsl:message>
        </xsl:if>
        <xsl:apply-templates select="self::*" mode="CONSTRUCT"/>
    </xsl:template>
    <xsl:template match="xsl:*"/>
    <xsl:template match="*">
        <xsl:copy>
            <xsl:apply-templates select="@* | *[not(@tpl:else)] | text() | comment()"/>
        </xsl:copy>
    </xsl:template>

    <xsl:template match="*[@tpl:foreach]" mode="CONSTRUCT">
        <xsl:element name="xsl:for-each" namespace="{$xsl}">
            <xsl:attribute name="select"><xsl:value-of select="@tpl:foreach"/></xsl:attribute>
            <xsl:if test="@tpl:with-order">
                <xsl:element name="xsl:sort" namespace="{$xsl}">
                    <xsl:attribute name="select"><xsl:value-of select="@tpl:with-order"/></xsl:attribute>
                </xsl:element>
            </xsl:if>
            <xsl:apply-templates select="self::*" mode="VARIABLE"/>
        </xsl:element>
    </xsl:template>
    <xsl:template match="*[@tpl:foreach-token]" mode="CONSTRUCT">
        <xsl:element name="xsl:call-template" namespace="{$xsl}">
            <xsl:attribute name="name">tokenize</xsl:attribute>
            <xsl:element name="xsl:with-param" namespace="{$xsl}">
                <xsl:attribute name="name">string</xsl:attribute><xsl:attribute name="select"><xsl:value-of select="@tpl:foreach-token"/></xsl:attribute>
            </xsl:element>
            <xsl:element name="xsl:with-param" namespace="{$xsl}">
                <xsl:attribute name="name">delimiter</xsl:attribute><xsl:value-of select="@tpl:with-delimiter"/>
            </xsl:element>
            <xsl:element name="xsl:with-param" namespace="{$xsl}">
                <xsl:attribute name="name">callback</xsl:attribute><xsl:value-of select="count(preceding::*[@tpl:foreach-token])+1"/>
            </xsl:element>
        </xsl:element>
    </xsl:template>
    <xsl:template match="*[@tpl:if]" mode="CONSTRUCT">
        <xsl:element name="xsl:choose" namespace="{$xsl}">
            <xsl:element name="xsl:when" namespace="{$xsl}">
                <xsl:attribute name="test"><xsl:value-of select="@tpl:if"/></xsl:attribute>
                <xsl:apply-templates select="self::*" mode="VARIABLE"/>
            </xsl:element>
            <xsl:apply-templates select="following-sibling::*[1][@tpl:else]"/>
        </xsl:element>
    </xsl:template>
    <xsl:template match="*[@tpl:else]" mode="CONSTRUCT">
        <xsl:choose>
            <xsl:when test="@tpl:else != ''">
                <xsl:element name="xsl:when" namespace="{$xsl}">
                    <xsl:attribute name="test"><xsl:value-of select="@tpl:else"/></xsl:attribute>
                    <xsl:apply-templates select="self::*" mode="VARIABLE"/>
                </xsl:element>
            </xsl:when>
            <xsl:otherwise>
                <xsl:element name="xsl:otherwise" namespace="{$xsl}">
                    <xsl:apply-templates select="self::*" mode="VARIABLE"/>
                </xsl:element>
            </xsl:otherwise>
        </xsl:choose>
        <xsl:apply-templates select="following-sibling::*[1][@tpl:else]"/>
    </xsl:template>
    <xsl:template match="*" mode="CONSTRUCT">
        <xsl:apply-templates select="self::*" mode="VARIABLE"/>
    </xsl:template>

    <xsl:template match="*" mode="VARIABLE">
        <xsl:for-each select="@tpl:*[starts-with(local-name(), 'variable.')]">
            <xsl:element name="xsl:variable" namespace="{$xsl}">
                <xsl:attribute name="name"><xsl:value-of select="substring-after(local-name(), 'variable.')"/></xsl:attribute>
                <xsl:attribute name="select"><xsl:value-of select="."/></xsl:attribute>
            </xsl:element>
        </xsl:for-each>
        <xsl:apply-templates select="self::*" mode="REMOVE_TAG"/>
    </xsl:template>

    <xsl:template match="*[@tpl:remove-tag]" mode="REMOVE_TAG">
        <xsl:element name="xsl:choose" namespace="{$xsl}">
            <xsl:element name="xsl:when" namespace="{$xsl}">
                <xsl:attribute name="test"><xsl:value-of select="@tpl:remove-tag"/></xsl:attribute>
                <xsl:apply-templates select="self::*" mode="LEAF"/>
            </xsl:element>
            <xsl:element name="xsl:otherwise" namespace="{$xsl}">
                <xsl:copy>
                    <xsl:apply-templates select="self::*" mode="ATTRIBUTE"/>
                    <xsl:apply-templates select="self::*" mode="LEAF"/>
                </xsl:copy>
            </xsl:element>
        </xsl:element>
    </xsl:template>
    <xsl:template match="*" mode="REMOVE_TAG">
        <xsl:copy>
            <xsl:apply-templates select="self::*" mode="ATTRIBUTE"/>
            <xsl:apply-templates select="self::*" mode="LEAF"/>
        </xsl:copy>
    </xsl:template>

    <xsl:template match="*" mode="ATTRIBUTE">
        <xsl:apply-templates select="@*"/>
        <xsl:for-each select="@tpl:*[starts-with(local-name(), 'remove-attribute.')]">
            <xsl:variable name="attributeName" select="substring-after(local-name(), 'remove-attribute.')"/>
            <xsl:element name="xsl:if" namespace="{$xsl}">
                <xsl:attribute name="test">not(<xsl:value-of select="."/>)</xsl:attribute>
                <xsl:element name="xsl:attribute" namespace="{$xsl}">
                    <xsl:attribute name="name"><xsl:value-of select="$attributeName"/></xsl:attribute>
                    <xsl:choose>
                        <xsl:when test="parent::*/@tpl:*[local-name()=$attributeName]">
                            <xsl:element name="xsl:value-of" namespace="{$xsl}">
                                <xsl:attribute name="select"><xsl:value-of select="parent::*/@tpl:*[local-name()=$attributeName]"/></xsl:attribute>
                            </xsl:element>
                        </xsl:when>
                        <xsl:when test="parent::*/@*[local-name()=$attributeName]">
                            <xsl:call-template name="TEXT">
                                <xsl:with-param name="string" select="parent::*/@*[local-name()=$attributeName]"/>
                            </xsl:call-template>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:message terminate="yes">ERROR: attribute '<xsl:value-of select="$attributeName"/>' can not be removed because it does not exist</xsl:message>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:element>
            </xsl:element>
        </xsl:for-each>
    </xsl:template>

    <xsl:template match="*[@tpl:text]" mode="LEAF">
        <xsl:element name="xsl:value-of" namespace="{$xsl}">
            <xsl:attribute name="select"><xsl:value-of select="@tpl:text"/></xsl:attribute>
        </xsl:element>
        <xsl:apply-templates select="comment()"/>
    </xsl:template>
    <xsl:template match="*[@tpl:xml]" mode="LEAF">
        <xsl:element name="xsl:apply-templates" namespace="{$xsl}">
            <xsl:attribute name="select"><xsl:value-of select="@tpl:xml"/></xsl:attribute>
            <xsl:attribute name="mode">serialize</xsl:attribute>
        </xsl:element>
        <xsl:apply-templates select="comment()"/>
    </xsl:template>
    <xsl:template match="*[@tpl:call-function]" mode="LEAF">
        <xsl:element name="xsl:call-template" namespace="{$xsl}">
            <xsl:attribute name="name"><xsl:value-of select="@tpl:call-function"/></xsl:attribute>
            <xsl:for-each select="@tpl:*[starts-with(local-name(), 'with-param.')]">
                <xsl:element name="xsl:with-param" namespace="{$xsl}">
                    <xsl:attribute name="name"><xsl:value-of select="substring-after(local-name(), 'with-param.')"/></xsl:attribute>
                    <xsl:attribute name="select"><xsl:value-of select="."/></xsl:attribute>
                </xsl:element>
            </xsl:for-each>
        </xsl:element>
        <xsl:apply-templates select="comment()"/>
    </xsl:template>
    <xsl:template match="*[@tpl:duplicate]" mode="LEAF">
        <xsl:element name="xsl:call-template" namespace="{$xsl}">
            <xsl:attribute name="name"><xsl:value-of select="@tpl:duplicate"/></xsl:attribute>
        </xsl:element>
    </xsl:template>
    <xsl:template match="*" mode="LEAF">
        <xsl:apply-templates select="*[not(@tpl:else)] | text() | comment()"/>
    </xsl:template>

    <!-- TEMPLATE ATTRIBUTES -->

    <xsl:template match="@tpl:foreach|@tpl:with-order|@tpl:foreach-token|@tpl:with-delimiter|@tpl:if|@tpl:else
        |@tpl:text|@tpl:call-function|@tpl:duplicate|@tpl:remove-tag
        |@tpl:*[starts-with(local-name(),'remove-attribute.')]
        |@tpl:*[starts-with(local-name(),'variable.')]
        |@tpl:*[starts-with(local-name(),'with-param.')]"/>
    <xsl:template match="@tpl:*">
        <!-- do not copy attributes that may be removed -->
        <xsl:if test="not(parent::*/@tpl:*[local-name()=concat('remove-attribute.',local-name(current()))])">
            <xsl:attribute name="{local-name()}">{<xsl:value-of select="."/>}</xsl:attribute>
        </xsl:if>
    </xsl:template>

    <!-- SHORT NOTATION {{XPath}} -->

    <xsl:template match="@*">
        <!-- do not copy attributes that may be removed -->
        <!-- do not copy attributes that will be replaced with @tpl:* -->
        <xsl:if test="not(parent::*/@tpl:*[local-name()=concat('remove-attribute.',local-name(current()))])
                  and not(parent::*/@tpl:*[local-name()=local-name(current())])">
            <xsl:attribute name="{local-name()}">
                <xsl:call-template name="ATTRIBUTE"><xsl:with-param name="string" select="."/></xsl:call-template>
            </xsl:attribute>
        </xsl:if>
    </xsl:template>
    <xsl:template match="text()">
        <!-- do not copy text() that will be replaced with @tpl:text -->
        <xsl:if test="not(parent::*/@tpl:text | parent::*/@tpl:call-function)">
            <xsl:call-template name="TEXT"><xsl:with-param name="string" select="."/></xsl:call-template>
        </xsl:if>
    </xsl:template>
    <xsl:template match="comment()">
        <xsl:element name="xsl:comment" namespace="{$xsl}">
            <xsl:value-of select="."/>
        </xsl:element>
    </xsl:template>

    <!-- FUNCTIONS -->
    <xsl:template name="ATTRIBUTE">
        <xsl:param name="string"/>
        <xsl:choose>
            <xsl:when test="contains($string,'{{')">
                <xsl:variable name="remains" select="substring-after($string,'{{')"/>
                <xsl:value-of select="substring-before($string,'{{')"/>
                <xsl:text>{</xsl:text>
                <xsl:value-of select="substring-before($remains,'}}')"/>
                <xsl:text>}</xsl:text>
                <xsl:call-template name="ATTRIBUTE">
                    <xsl:with-param name="string" select="substring-after($remains,'}}')"/>
                </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
                <xsl:value-of select="$string"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template name="TEXT">
        <xsl:param name="string"/>
        <xsl:choose>
            <xsl:when test="contains($string,'{{')">
                <xsl:variable name="remains" select="substring-after($string,'{{')"/>
                <xsl:value-of select="substring-before($string,'{{')"/>
                <xsl:element name="xsl:value-of" namespace="{$xsl}">
                    <xsl:attribute name="select"><xsl:value-of select="substring-before($remains,'}}')"/></xsl:attribute>
                </xsl:element>
                <xsl:call-template name="TEXT">
                    <xsl:with-param name="string" select="substring-after($remains,'}}')"/>
                </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
                <xsl:value-of select="$string"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
</xsl:stylesheet>